# -*- coding: latin1 -*-

import errores

_globales= {}
_locales= {}
_tactual= _globales
_factual= None

def entraFuncion(f):
  global _tactual, _locales, _factual
  _locales= {}
  _tactual= _locales
  _factual= f

def salFuncion():
  global _tactual, _factual
  _tactual= _globales
  _factual= None

def existe(id):
  return _tactual.has_key(id) or ( _tactual is _locales and _globales.has_key(id))

def recupera(id):
  if _tactual.has_key(id):
    return _tactual[id]
  else:
    return _globales.get(id, None)

def define(id, info, linea):
  if _tactual.has_key(id):
    errores.semantico("Error, el identificador %s ya est definido en este mbito." % id, linea)
  else:
    _tactual[id]= info

def enFuncion():
  return _factual
